export default {
  namespace: "ticTacToe",
  state: {
    history: [
      {
        squares: Array(9).fill(null)
      }
    ],
    stepNumber: 0,
    xIsNext: true,
    backgroundColor: null
  },

  reducers: {
    // 落子
    nextStep(state, { payload: index }) {
      let history = state.history.slice(0, state.stepNumber + 1);
      let current = history[history.length - 1];
      let squares = current.squares.slice();
      squares[index] = state.xIsNext ? "X" : "O";

      return {
        history: history.concat([{ squares: squares }]),
        stepNumber: history.length,
        xIsNext: !state.xIsNext,
        backgroundColor: state.xIsNext ? "blue" : "red"
      }
    },

    // 回跳
    jumpTo(state, { payload: stepNumber }) {
      return {
        ...state,
        stepNumber: stepNumber,
        xIsNext: (stepNumber % 2) === 0
      }
    }
  }
}
